package kck.gui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.util.Vector;

import javax.swing.JComponent;

import kck.logic.ColorScale;
import kck.logic.HTDData;

public class Drawing extends JComponent {
	private ColorScale cs;
	private Vector layers;
	
	private static final long serialVersionUID = 1L;

	public Drawing() {
		cs = new ColorScale();
		layers = new Vector();
	}
	
	public void clearLayers() {
		layers.clear();
	}
	
	public void addLayer(HTDData layer) {
		layers.add(layer);
	}	
	
	public int getWidth() {
		return (layers.size() == 0) ? 640 : (int)(((HTDData)layers.get(0)).getMaxx() - ((HTDData)layers.get(0)).getMinx());
	}
	
	public int getHeight() {
		return (layers.size() == 0) ? 480 : (int)(((HTDData)layers.get(0)).getMaxy() - ((HTDData)layers.get(0)).getMiny());
	}
	
	public Dimension getPreferredSize() {
		return new Dimension(getWidth(), getHeight());
	}
	
	public void paint(Graphics g) {
		int i;
		Rectangle r = g.getClipBounds();
		
		if (layers.size() > 0) {
			g.setColor(Color.WHITE);
			g.fillRect(0, 0, (int)(((HTDData)layers.get(0)).getMaxx() - ((HTDData)layers.get(0)).getMinx()), (int)(((HTDData)layers.get(0)).getMaxy() - ((HTDData)layers.get(0)).getMinx()));
			
			for (i=0; i<layers.size(); i++) {
				g.drawImage(((HTDData)layers.get(i)).getDataDraw(), 0, 0, this);
			}
			
			for (i=0; i<= 200; i++) {
				g.setColor(cs.getColorValue(i*5));
				g.fillRect(r.x + 10 + i, r.y + 10, 1, 20);
			}
			
		} else {
			g.setColor(Color.WHITE);
			g.fillRect(0, 0, getWidth(), getHeight());
		}
	}
}
