package kck.logic;

import java.awt.Color;

public class ColorScale {
	private HTDData data;
	private int mode;
	
	public void setMode(int mode) {
		this.mode = mode;
	}
	
	private int minValue() {
		switch (mode) {
		case (1): return 400;
		case (2): return 0;
		default: return 0;
		}
	}
	
	private int maxValue() {
		switch (mode) {
		case (1): return 1400;
		case (2): return 900;
		default: return HTDData.maxPressure;
		}
	}
	
	private int getValue(int i) {
		switch (mode) {
		case (1): return data.azimuth[i];
		case (2): return data.altitude[i];
		default: return data.pressure[i];
		}
	}
	
	public Color getColorValue(int value) {
		int maxf = maxValue();
		
		if (value > maxf) {
			value = maxf;
		}
		
		if (value == 0) {
			return Color.WHITE;
		} else {	
			if (((double)value/maxf)<0.5) {
				return new Color(250, 0, (int)(((double)value/maxf)*2*250));
			} else  {
				return new Color((int)((double)2*(1.0 - (double)value/maxf)*250), 0, 250);
			}
		}	
	
	}
	
	public Color getColor(int i) {
		int value = Math.max(0, getValue(i) - minValue());
		return getColorValue(value);
	}
	
	public void setData(HTDData data) {
		this.data = data;
	}
}
