
package src.gui;

import javax.swing.Box;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSlider;
import javax.swing.JFileChooser;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.UIManager;

import java.awt.Dimension;
import java.awt.GridLayout;
import javax.swing.BoxLayout;
import javax.swing.BorderFactory;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.filechooser.FileFilter;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.Color;
import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.text.DecimalFormat;
import javax.swing.ButtonGroup;

import javax.sound.sampled.*;

//import src.gui.CreateReport;
import javax.swing.JOptionPane;
import javax.swing.JDialog;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;

public class kckDzwieki extends JFrame {
	private static final long serialVersionUID = 1L;
	private static final int EXTERNAL_BUFFER_SIZE = 128000;
	
	private AudioInputStream streamA;
	private AudioInputStream streamB;
	private File fileA;
	private File fileB;
	private File random;
	
	private boolean stopPlayingFlag;
	private boolean correctAnswer;
	private int correctAnswersCount;
	private int answersCount;
	private double confidLevel = 0.05;
	
	private JLabel startSliderValue;
	private JLabel stopSliderValue;
	private JButton soundA;
	private JButton soundB;
	private JButton soundX;
	private JSlider startSlider;
	private JSlider stopSlider;
	private JCheckBox xIsA;
	private JCheckBox xIsB;
	private JLabel statusLabel;
	private JPanel buttonsPanel;
	private JPanel slidersPanel;
	private JPanel slider1Panel;
	private JPanel slider2Panel;
	private JPanel checkboxesPanel;
	private JPanel statusPanel;
	private JMenuBar menu;
	private JMenu menu_file;
	private JMenu menu_report;
	private JMenu menu_confidence;
	//private JMenu menu_stop;
	private JMenuItem file_open_a;
	private JMenuItem file_open_b;
	private JMenuItem file_exit;
	private JMenuItem report_show;
	private JMenuItem report_reset;
	private JRadioButtonMenuItem confid1;
	private JRadioButtonMenuItem confid2;
	private JRadioButtonMenuItem confid3;
	private ButtonGroup confidGroup;
	private JDialog reportDialog;
	JFileChooser fc;
	
	private void initComponents()
	{
		try {
  		  UIManager.setLookAndFeel(
  		  UIManager.getSystemLookAndFeelClassName());
  		} catch (Exception e) {
  		}
		setDefaultLookAndFeelDecorated(true);
		
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		reportDialog = new JDialog(this, "Report", true);
		
		fc  = new JFileChooser();
		
		correctAnswersCount = 0;
		answersCount = 0;
		
		setTitle("kckDzwieki");
		
		menu = new JMenuBar();
		menu_file = new JMenu("File");
		menu_report = new JMenu("Report");
		//menu_stop = new JMenu("Stop");
		menu.add(menu_file);
		menu.add(menu_report);
		//menu.add(menu_stop);
		file_open_a = new JMenuItem("Open A...");
		file_open_b = new JMenuItem("Open B...");
		file_exit = new JMenuItem("Exit");
		report_show = new JMenuItem("Show...");
		report_reset = new JMenuItem("Reset");
		
		menu_confidence = new JMenu("Confidence level");
		confidGroup = new ButtonGroup();
		confid1 = new JRadioButtonMenuItem("0.05");
		confidGroup.add(confid1);
		confid1.setSelected(true);
		confid1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				confidLevel = 0.05;
			}
		});
		menu_confidence.add(confid1);
		confid2 = new JRadioButtonMenuItem("0.03");
		confidGroup.add(confid2);
		confid2.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				confidLevel = 0.03;
			}
		});
		menu_confidence.add(confid2);

		confid3 = new JRadioButtonMenuItem("0.01");
		confidGroup.add(confid3);
		menu_confidence.add(confid3);
		confid3.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				confidLevel = 0.01;
			}
		});
		
		menu_file.add(file_open_a);
		menu_file.add(file_open_b);
		menu_file.addSeparator();
		menu_file.add(file_exit);
		menu_report.add(report_show);
		menu_report.add(menu_confidence);
		menu_report.addSeparator();
		menu_report.add(report_reset);
		setJMenuBar(menu);
		
		soundA = new JButton("A");
		soundB = new JButton("B");
		soundX = new JButton("X");
		
		soundA.setEnabled(false);
		soundB.setEnabled(false);
		soundX.setEnabled(false);
		
		buttonsPanel = new JPanel();
		buttonsPanel.setLayout(new GridLayout(0,3));
		buttonsPanel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		buttonsPanel.add(soundA);
		buttonsPanel.add(soundX);
		buttonsPanel.add(soundB);
		
		startSliderValue = new JLabel("0:00:00.00");
		stopSliderValue = new JLabel("0:00:00.00");
		
		startSlider = new JSlider();
		startSlider.setValue(0);
		startSlider.setMinimum(0);
		startSlider.setMaximum(0);
		startSlider.setMajorTickSpacing(1000);
		startSlider.setPaintTicks(true);
		
		stopSlider = new JSlider();
		stopSlider.setValue(0);
		stopSlider.setMinimum(0);
		stopSlider.setMaximum(0);
		stopSlider.setPaintTicks(true);
		stopSlider.setMajorTickSpacing(1000);
		
		startSlider.setEnabled(false);
		stopSlider.setEnabled(false);
		
		slider1Panel = new JPanel();
		slider1Panel.setLayout(new BoxLayout(slider1Panel, BoxLayout.LINE_AXIS));
		slider1Panel.add(new JLabel("Start"));
		slider1Panel.add(Box.createHorizontalGlue());
		slider1Panel.add(startSliderValue);
		slider1Panel.setBorder(BorderFactory.createEmptyBorder(0, 10, 0, 10));
		
		slider2Panel = new JPanel();
		slider2Panel.setLayout(new BoxLayout(slider2Panel, BoxLayout.LINE_AXIS));
		slider2Panel.add(new JLabel("Stop"));
		slider2Panel.add(Box.createHorizontalGlue());
		slider2Panel.add(stopSliderValue);
		slider2Panel.setBorder(BorderFactory.createEmptyBorder(0, 10, 0, 10));
		
		slidersPanel = new JPanel();		
		slidersPanel.setLayout(new BoxLayout(slidersPanel, BoxLayout.PAGE_AXIS));
		slidersPanel.add(slider1Panel);
		slidersPanel.add(startSlider);
		slidersPanel.add(slider2Panel);
		slidersPanel.add(stopSlider);

		xIsA = new JCheckBox("X is sound A");
		xIsB = new JCheckBox("X is sound B");
		
		xIsA.setEnabled(false);
		xIsB.setEnabled(false);
		
		checkboxesPanel = new JPanel();
		checkboxesPanel.setLayout(new BoxLayout(checkboxesPanel, BoxLayout.PAGE_AXIS));
		checkboxesPanel.add(xIsA);
		checkboxesPanel.add(xIsB);
		
		statusPanel = new JPanel();
		statusPanel.setLayout(new BoxLayout(statusPanel, BoxLayout.LINE_AXIS));
		statusLabel = new JLabel("Open the sound files...");
		statusPanel.add(statusLabel);
		statusPanel.add(Box.createHorizontalGlue());
		statusPanel.setAlignmentX(0);
		
		statusPanel.setBorder(BorderFactory.createMatteBorder(1,1,1,1,Color.GRAY));
		
		getContentPane().setLayout(new BoxLayout(getContentPane(), BoxLayout.PAGE_AXIS));
		getContentPane().add(buttonsPanel);
		getContentPane().add(slidersPanel);
		getContentPane().add(checkboxesPanel);
		checkboxesPanel.setAlignmentX(JComponent.RIGHT_ALIGNMENT);
		getContentPane().add(statusPanel);
		statusPanel.setAlignmentX(JComponent.CENTER_ALIGNMENT);
		
		setLocation(100, 100);
		pack();
	}
	
	private String printTime(long time)
	{
		long hours, mins, secs, misecs;
		DecimalFormat nf = new DecimalFormat("00");
		hours = time / 360000;
		mins = (time % 360000) / 6000;
		secs = (time % 6000) / 100;
		misecs = time % 100;
		return new String(nf.format(hours)+":"+nf.format(mins)+":"+nf.format(secs)+"."+nf.format(misecs));
	}
	
	private void initActions()
	{
		startSlider.addChangeListener(new ChangeListener(){
			public void stateChanged(ChangeEvent e)
			{
				JSlider source = (JSlider)e.getSource();
				startSliderValue.setText(printTime(source.getValue()));
				if (source.getValue() > stopSlider.getValue())
				{
					stopSlider.setValue(startSlider.getValue());
				}
			}
		});
	
		stopSlider.addChangeListener(new ChangeListener(){
			public void stateChanged(ChangeEvent e)
			{
				JSlider source = (JSlider)e.getSource();
				stopSliderValue.setText(printTime(source.getValue()));
				if (source.getValue() < startSlider.getValue())
				{
					startSlider.setValue(stopSlider.getValue());
				}
			}
		});
		
		file_open_a.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{
				fc.setFileFilter(new FileFilter(){public boolean accept(File f){return f.isDirectory() || f.getName().endsWith(".wav");}; public String getDescription(){return "Wave sound file (*.wav)";};});
				
				
				if (fc.showOpenDialog(kckDzwieki.this) == JFileChooser.APPROVE_OPTION)
				{
					if ((streamA = openStream(fc.getSelectedFile())) != null)
					{
						fileA = fc.getSelectedFile();
						soundA.setEnabled(true);
						reenableControls();
					}
					else
					{
						soundA.setEnabled(false);
					}
				}
			}
		});
		
		file_open_b.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{
				fc.setFileFilter(new FileFilter(){public boolean accept(File f){return f.isDirectory() || f.getName().endsWith(".wav");}; public String getDescription(){return "Wave sound file (*.wav)";};});
				
				if (fc.showOpenDialog(kckDzwieki.this) == JFileChooser.APPROVE_OPTION)
				{
					if ((streamB = openStream(fc.getSelectedFile())) != null)
					{
						fileB = fc.getSelectedFile();
						soundB.setEnabled(true);
						reenableControls();
					}
					else
					{
						soundB.setEnabled(false);
					}
					
				}
			}
		});
		
		/*
		menu_stop.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				stopPlayingFlag = true;
			}
		});
		*/
		
		report_show.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				final JOptionPane optionPane;
				JPanel panel = new JPanel();
				
				JTextField decisionMaker = new JTextField();
				JTextField usedHardware = new JTextField();
				JTextArea comments = new JTextArea(5, 20);
				JScrollPane commentsscroll = new JScrollPane(comments, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
                        JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);

				decisionMaker.setText("<Your Name>");
				usedHardware.setText("<Your soundcard and speakers>");
				comments.setText("<Additional comments>");
				
				panel.setLayout(new BoxLayout(panel, BoxLayout.PAGE_AXIS));
				panel.add(decisionMaker);
				
				panel.add(Box.createRigidArea(new Dimension(0, 5)));
				panel.add(usedHardware);
				
				panel.add(Box.createRigidArea(new Dimension(0, 5)));
				panel.add(commentsscroll);
				
				optionPane = new JOptionPane(panel, JOptionPane.QUESTION_MESSAGE, JOptionPane.OK_CANCEL_OPTION);
				
				reportDialog.setContentPane(optionPane);
				reportDialog.setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
				reportDialog.addWindowListener(new WindowAdapter() {
					public void windowClosing(WindowEvent we) {
						statusLabel.setText("Thwarted user attempt to close window.");
					}
				});
				optionPane.addPropertyChangeListener(
					new PropertyChangeListener() {
						public void propertyChange(PropertyChangeEvent e) {
						String prop = e.getPropertyName();

			            if (reportDialog.isVisible() 
			             && (e.getSource() == optionPane)
			             && (prop.equals(JOptionPane.VALUE_PROPERTY))) {
			                //If you were going to check something
			                //before closing the window, you'd do
			                //it here.
		            		reportDialog.setVisible(false);
		            	}
					}
				});
			reportDialog.pack();
			reportDialog.setVisible(true);

			int value = ((Integer)optionPane.getValue()).intValue();
			if (value == JOptionPane.YES_OPTION) {
					File reportfile = new File("report.html");
			    	if (! outputReport(reportfile, decisionMaker.getText(), usedHardware.getText(), comments.getText()))
			    	{
			    		statusLabel.setText("Can't create report.xml");
			    	}
			    	else
			    	{
			    		try {
							Runtime.getRuntime().exec("cmd /C start iexplore.exe "+reportfile.getAbsolutePath());
						} catch (Exception ex) {}
			    	}
				}
			}
			});
		
		report_reset.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				correctAnswersCount = 0;
				answersCount = 0;
			}
		});
		
		soundA.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				play(fileA);
			}
		});
		
		soundB.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				play(fileB);
			}
		});
		
		soundX.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				if (random == null)
				{
					correctAnswer = (Math.random() > 0.5);
					random =  correctAnswer ? fileA : fileB;
				}
				
				xIsA.setEnabled(true);
				xIsB.setEnabled(true);
				
				play(random);
			}
		});
		
		xIsA.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				if (correctAnswer)
				{
					correctAnswersCount++;
					statusLabel.setText("Success!");
				}
				else
				{
					statusLabel.setText("Wrong");
				}
				answersCount++;
				
				xIsA.setEnabled(false);
				xIsB.setEnabled(false);
				xIsA.setSelected(false);
				random = null;
			}
		});
		
		xIsB.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				if (! correctAnswer)
				{
					correctAnswersCount++;
					statusLabel.setText("Success!");
				}
				else
				{
					statusLabel.setText("Wrong");
				}
				answersCount++;
				
				xIsA.setEnabled(false);
				xIsB.setEnabled(false);
				xIsB.setSelected(false);
				random = null;
			}
		});
		
		file_exit.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{
				Runtime.getRuntime().exit(0);
			}
		});
		
	}
	
	public double B(int x, int n,double p)
	{
		int i=0;
		int k;
		double j;
		double statistics = 0;
		
		if (n > 0)
		{
			for (i=x; i<=n; i++)
			{
				j = Math.pow(p, i)*Math.pow(1-p, n-i);
				for (k=1; k<=n; k++)
				{
					j *= k;
				}
				for (k=1; k<=i; k++)
				{
					j /= k;
				}
				for (k=1; k<=n-i; k++)
				{
					j /= k;
				}
				statistics += j;
			}
		}
		
		return statistics;
	}
	
	public boolean outputReport(File outFile, String decisionMaker, String usedHardware, String comments)
	{
		OutputStreamWriter out;
		double statistics = B(correctAnswersCount, answersCount, 0.5);
		boolean decision;
		
	    try {
	      out = new OutputStreamWriter(new FileOutputStream(outFile), "UTF-8");
	      out.write("<html><head><meta http-equiv='Content-Type' content='text/html; charset=UTF-8'><title>Raport</title><style>th {text-align: left}</style></head><body>");
	      
	      out.write("<h1>Raport</h1><h2>Wyniki</h2>");
	      out.write("<table><tr><th>Poprawnych odp.</th><td>"+correctAnswersCount+"</td></tr><tr><th>Razem odp.</th><td>"+answersCount+"</td></tr><tr><th>Odsetek poprawnych</th><td>"+(answersCount == 0? 0 : ((float)correctAnswersCount/answersCount))+"</td></tr></table>");
	      
	      out.write("<h2>Statystyka</h2>");
	      if (answersCount > 15)
	      {
	    	  decision = Math.abs(statistics) < confidLevel; 
	    	  out.write("<table><tr><th>B</th><td>"+statistics+"</td></tr><tr><th>Poziom ufnoci</th><td>"+confidLevel+"</td></tr><tr><th>H0</th><td>Dwiki A i B jednakowe</td></tr><tr><th>H1</th><td>Dwiki A i B s rne</td></tr><tr><th>Decyzja</th><td>"+(decision ? "Naley odrzuci H0":"Nie mona odrzuci H0")+"</td></tr></table>");
	      }
	      else
	      {
	    	  out.write("<div style='color: red'>Zbyt maa liczno prby. Do statystyki wymagane jest conajmniej 16 losowa.</div>");
	      }
	      
	      out.write("<h2>Parametry eksperymentu</h2>");
	      out.write("<table><tr></tr><tr><th>Decydent</th><td>"+decisionMaker+"</td></tr><tr><th>Sprzt</th><td>"+usedHardware+"</td></tr><tr><th>Uwagi</th><td>"+comments+"</td></tr></table>");
	      
	      out.write("</body></html>");
	      out.close();
	    } catch(Exception e) {
	    	return false;
	    }
		return true;
	}
	
	private void reenableControls()
	{
		boolean enabled = false;
		long tmp, maxtime = 0; // maxtime is minimum length of two sounds
		
		if ((streamA != null) || (streamB != null))
		{
			if (streamA != null)
			{
				AudioFormat af = streamA.getFormat();
				maxtime = (long)((float)streamA.getFrameLength()*100/af.getFrameRate());
				
			}
			if (streamB != null)
			{
				AudioFormat af = streamB.getFormat();
				tmp = (long)((float)streamB.getFrameLength()*100/af.getFrameRate());
				maxtime = ((maxtime == 0) || (maxtime > tmp)) ? tmp : maxtime;
			}
			
			startSlider.setMaximum((int)maxtime);
			stopSlider.setMaximum((int)maxtime);
			
			if (stopSlider.getValue() == 0)
			{
				stopSlider.setValue((int)maxtime);
			}
			
			enabled = true;
		}
		
		soundX.setEnabled((streamA != null) && (streamB != null));
		startSlider.setEnabled(enabled);
		stopSlider.setEnabled(enabled);
	}
	
	private AudioInputStream openStream(File soundFile)
	{
		AudioInputStream result = null;
		statusLabel.setText(soundFile.getAbsolutePath());
		try {
			result = AudioSystem.getAudioInputStream(soundFile);
		} catch (Exception ex)
		{
			statusLabel.setText("Invalid file");
		}
		return result;
	}
	
	private void play(File file)
	{
		AudioInputStream stream = openStream(file);
		AudioFormat af = stream.getFormat();
		SourceDataLine line = null;
		long startPos = ((long)(startSlider.getValue()*(af.getFrameRate()/100)*af.getFrameSize()));
		long bytesToPlay = ((long)(stopSlider.getValue()*(af.getFrameRate()/100)*af.getFrameSize()) - startPos);
		long currPos = startPos;
		
		startPos = (startPos % (af.getSampleSizeInBits()/8))==0 ? startPos : startPos - (startPos % (af.getSampleSizeInBits()/8));  
		bytesToPlay = (bytesToPlay % (af.getSampleSizeInBits()/8))==0 ? bytesToPlay : bytesToPlay - (bytesToPlay % (af.getSampleSizeInBits()/8));
		
		DataLine.Info info = new DataLine.Info(SourceDataLine.class, af);
		
		try {
			line = (SourceDataLine) AudioSystem.getLine(info);
			line.open(af);
		} 
		catch (LineUnavailableException ex)
		{
			statusLabel.setText("Can't open sound device");
		}
		catch (Exception ex)
		{
			statusLabel.setText("Can't play sound");
		}
		
		line.start();
		
		try {
			while (startPos > 0)
			{
				startPos -= stream.skip(startPos);
			}
		}
		catch (Exception ex)
		{
			statusLabel.setText("Sound file error");
		}
		
		stopPlayingFlag = false;
		
		int	nBytesRead = 0;
		int bytesToRead;
		byte[]	abData = new byte[EXTERNAL_BUFFER_SIZE];
		while ((nBytesRead != -1) && (bytesToPlay > 0) && (! stopPlayingFlag))
		{
			try
			{
				bytesToRead = (int) ((bytesToPlay < (long)abData.length) ? bytesToPlay : abData.length);
				nBytesRead = stream.read(abData, 0, bytesToRead);
				bytesToPlay -= nBytesRead;
				currPos += nBytesRead;
			}
			catch (Exception ex) { statusLabel.setText("Play error"); }
			if (nBytesRead >= 0)
			{
				line.write(abData, 0, nBytesRead);
			}
			
			//statusLabel.setText((int)(currPos/(af.getFrameRate()*af.getFrameSize()))+"s");
		}

		stopPlayingFlag = false;
		
		line.drain();
		line.close();
		try {
		stream.close();
		} catch (Exception ex) {};
		
		if (answersCount > 0)
		{
			statusLabel.setText(correctAnswersCount+"/"+answersCount+" ("+((float)correctAnswersCount/answersCount)+")");
		}
	}
	
	public static void main(String[] args) {
		javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                kckDzwieki appMainWindow = new kckDzwieki();
                appMainWindow.initComponents();
                appMainWindow.initActions();
                appMainWindow.setVisible(true);
            }
        });
	}

}
