#!/usr/bin/perl

# parametry gry 

$rounds_c = 10; # liczba rund
$gamewidth = 3; # liczba pionkow do zgadniecia

# otwarcie sesji

@colors = ('c', 'n', 'z', 'r', 'b');

if (open(SESJA, "mastermind.txt"))
{
  chop($current = <SESJA>);
  chop($haslo = <SESJA>);
  chop($win = <SESJA>);
  while (<SESJA>)
  {
    chop($_);
    push @historia, $_;
  }
  close(SESJA);
}
else
{
  $current = 0;
  $haslo = '';
  for ($i=0; $i<$gamewidth; $i++)
    { $haslo .= $colors[int(rand(5))]; }
  $win = 0;
  @historia = ();
}
$save = 0;

# pobranie zadan od uzytkownika

if ($ENV{'REQUEST_METHOD'} eq 'POST')
{
  read(STDIN, $cmd, $ENV{'CONTENT_LENGTH'});
}
else
{
  $cmd = $ENV{'QUERY_STRING'};
}


# logika gry

$expected_round = scalar @historia;
$requested_round = $cmd;
$requested_round =~ s/.*round=//;

if ($cmd =~ /action=newgame/)
{
  $current = 0;
  $haslo = '';
  for ($i=0; $i<$gamewidth; $i++)
    { $haslo .= $colors[int(rand(5))]; }
  $win = 0;
  @historia = ();
  $save = 1;
}
elsif ($cmd =~ /action=hint/)
{
  $message = $haslo;
}
elsif (($cmd =~ /action=play&v0=(.)&v1=(.)&v2=(.)/) && ($win == 0) && ($expected_round == $requested_round))
{
  @proba = ($1,$2,$3);
  $current++;

  $edhaslo = $haslo;
  $dobrze=0;
  $blisko=0;

  for ($i=0; $i<$gamewidth; $i++)
  {
    if (substr($haslo, $i, 1) eq $proba[$i])
    {
      $dobrze++;
      $proba[$i] = $i;
      $edhaslo = substr($edhaslo,0,$i).' '.substr($edhaslo,$i+1);
    }
  }
  

  foreach (@proba)
  {
    if ($edhaslo =~ /$_/)
    {
      $blisko++;
      $message .= $_.'@'.$edhaslo.' ';
      $edhaslo =~ s/$_//; 
    }
  }

  if ($dobrze == $gamewidth)
  {
    $win=1;
  }

  push @historia, $1.$2.$3.','.$dobrze.','.$blisko;
  $save = 1;
}


# zapisanie sesji

if ($save)
{
  open(SESJAW, ">mastermind.txt");
  print SESJAW $current."\n";
  print SESJAW $haslo."\n";
  print SESJAW $win."\n";
  foreach (@historia)
  {
    print SESJAW $_."\n";
  }
  close(SESJAW);
}

# przygotowanie dynamicznych elementrow strony

$message = '<div class="msg">'.$message.'&nbsp;</div>';

for ($i=0; $i < $rounds_c; $i++)
{
  $opt_submit = '';
  $choose = '';
  $hints = '';

  if ($current == $rounds_c - $i - 1)
  {
    if ($win==0)
    {
      $opt_submit = '<td><input type="submit" value="Sprawd"></td>';
      for ($j=0; $j < $gamewidth; $j++)
      {
         $choose .= '<img src="mastermind/e.gif" onclick="zmien(\''.$j.'\','.(2**$j).')" id="g'.$j.'"><input id="v'.$j.'" type="hidden" name="v'.$j.'" value="e">';
      }
       $treasure = '<img src="mastermind/prize.jpg">';
    }
    else
    {
       $choose = '<img src="mastermind/win.gif">';
       $treasure = '<img src="mastermind/treasure.gif">';
    }

  } 
  elsif ($current > $rounds_c - $i -1)
  {
    @hist = split ',',  $historia[$rounds_c - $i -1];

    for ($j=0; $j < $gamewidth; $j++)
    {
       $choose .= '<img src="mastermind/'.substr($hist[0], $j, 1).'.gif">';
    }

    if ($current == $rounds_c)
    {
      $treasure = '<img src="mastermind/fail.gif">';
    }
  }

  $hints = '<img src="mastermind/aw.gif">' x $hist[1]. '<img src="mastermind/ab.gif">' x $hist[2];
  $rounds .= '<tr height="32"><td>'.($rounds_c - $i).'</td><td>'.$choose.'</td><td>'.$hints.'</td>'.$opt_submit.'</tr>';
}

# uwaga nadchodzimy

print "Content-Type: text/html\n\n";

# wydrukowanie strony razem z dynamicznymi elementami

print <<STR_HTML
<html>
<head>
  <meta http-equiv="content-type" content="text/html; charset=iso-8859-2"/>
  <title>Mastermind</title>
<style>
* { font-family: verdana, sans-serif; font-size: 10px; }
a {color: yellow; }
msg { height: 50px; color: white; }
</style>
<script>
l=0;
function zmien(pole,val)
{
  teraz = document.getElementById('v'+pole).value;
  switch (teraz)
  {
    case ('e'): nowy = 'c'; break; // empty
    case ('c'): nowy = 'n'; break; // czerwony
    case ('n'): nowy = 'z'; break; // niebieski
    case ('z'): nowy = 'r'; break; // zielony
    case ('r'): nowy = 'b'; break; // rozowy
    case ('b'): nowy = 'c'; break; // brazowy
  }
  document.getElementById('v'+pole).value = nowy;
  document.getElementById('g'+pole).src = 'mastermind/'+nowy+'.gif';
  l=l | val;
}
</script>
</head>
<body style="background-color: #909090">
<a href="mastermind.cgi?action=newgame">Nowa gra</a>&nbsp;&nbsp;<a href="mastermind.cgi?action=hint">Podpowiedz</a><br/>
$message
<form method="post" action="mastermind.cgi" onsubmit="return l==7">
<input type="hidden" name="action" value="play">

<table>
<tr><td>
<table cellspacing="0" cellpadding="0" border="0" style="padding: 10px; background-color: white; border: 2px solid blue">
<tr><th>&nbsp;</th><th></th><th width="50">&nbsp;</th></tr>
$rounds
</table>
</td><td valign="top" style="color: white">
Witaj!<br>
<br>
Zgadnij, o jakich trzech kolorach myl. Uporzdkuj je we waciwej kolejnoci.<br>
Daj Ci $rounds_c szans. Jeli zobacz, e dobrze gwkujesz, to:<br>
- dam ci biay eton za kad kulk waciwego koloru, na waciwym miejscu<br>
- dam ci czarny eton za kad kulk waciwego koloru, w zym miejscu<br>
<br>
Powodzenia!
<div style="padding-top: 50px; padding-left: 50px">
$treasure
</div>
</td></tr>
<input type="hidden" name="round" value="$current">
</form>
</body>
</html>
STR_HTML

