package servlets;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.servlet.RequestDispatcher;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;

/**
 * Servlet implementation class for Servlet: pracownicy
 *
 */
 public class pracownicy extends javax.servlet.http.HttpServlet implements javax.servlet.Servlet {
	private static final long serialVersionUID = 1L;
	private Connection con;
	private PreparedStatement deleteWorkerQuery = null;
	private PreparedStatement selectWorkerQuery = null;
	private PreparedStatement selectAllQuery = null;
	
	public pracownicy() {
		super();
		
		try {
			Class.forName("oracle.jdbc.driver.OracleDriver");
			con = DriverManager.getConnection("jdbc:oracle:thin:@dblab.cs.put.poznan.pl:1521:lab92", "inf66301", "lit40abc");

			deleteWorkerQuery = con.prepareStatement("DELETE FROM pracownicy WHERE id_prac = ?");
			selectWorkerQuery = con.prepareStatement("SELECT id_prac, nazwisko, etat, zatrudniony, placa_pod, placa_dod, nazwa, adres FROM pracownicy p LEFT OUTER JOIN zespoly z ON (p.id_zesp=z.id_zesp) WHERE id_prac = ?");
			selectAllQuery = con.prepareStatement("SELECT id_prac, nazwisko FROM pracownicy");
		} 
		catch (Exception e) {}
	}   	
	
	/* (non-Java-doc)
	 * @see javax.servlet.http.HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		String requestDispatcherStr = "lista.jsp";
		
		HttpSession session = request.getSession();
		ResultSet result;
		String output = "<table>";
		session.removeAttribute("message");
		
		if (request.getParameter("id_prac") != null)
		{
			int idPrac = Integer.parseInt(request.getParameter("id_prac"));
			
			if (request.getParameter("action") != null) // delete
			{
				try {
					deleteWorkerQuery.setInt(1, idPrac);
					deleteWorkerQuery.executeUpdate();
					session.setAttribute("message", "Pracownik zosta usunity");
				}
				catch (Exception e)
				{
					session.setAttribute("message", "SQLException: "+e.getMessage());
				}
			}
			else
			{ // list worker details
				try {
					selectWorkerQuery.setInt(1, idPrac);
					result = selectWorkerQuery.executeQuery();
					
					if (result.next())
					{
						session.setAttribute("id_prac", result.getString("id_prac"));
						session.setAttribute("nazwisko", result.getString("nazwisko"));
						session.setAttribute("etat", result.getString("etat"));
						session.setAttribute("zatrudniony", result.getString("zatrudniony"));
						session.setAttribute("placa_pod", result.getString("placa_pod"));
						session.setAttribute("placa_dod", result.getString("placa_dod"));
						session.setAttribute("zespol", result.getString("nazwa"));
						session.setAttribute("adres", result.getString("adres"));
						requestDispatcherStr = "pracownik.jsp";
					}
					else
					{
						session.setAttribute("message", "Nie ma takiego pracownika");
					}
					result.close();
				}
				catch (Exception e)
				{
					session.setAttribute("message", "SQLException: "+e.getMessage());
				}

			}

		}
		
		if (requestDispatcherStr.equals("lista.jsp"))
		{
			try {
				result = selectAllQuery.executeQuery();

				while (result.next())
				{
					output += "<tr><td>"+result.getString("id_prac")+"</td><td>"+result.getString("nazwisko")+"</td><td><a href=\"?id_prac="+result.getString("id_prac")+"\">szczegy</a>&nbsp;<a href=\"?action=delete&id_prac="+result.getString("id_prac")+"\">usu</a></td></tr>";
				}
				result.close();
			} 
			catch (Exception e)
			{
				session.setAttribute("message", "SQLException: "+e.getMessage());
			}
		}
		
		output += "</table>";
		session.setAttribute("workersListTable", output);
				
		RequestDispatcher dispatcher = request.getRequestDispatcher(requestDispatcherStr);
		if (dispatcher != null)
			dispatcher.forward(request, response);
	}

	public void destroy() {
		super.destroy();

		try {
			selectAllQuery.close();
			selectWorkerQuery.close();
			deleteWorkerQuery.close();
			con.close();
		}
		catch (Exception e) {}
	}
}