package orto.logic;

import java.util.Properties;
import java.io.*;

public class OrtoBean {
	private int questionNumber;
	private int correctAnswers;
	private int answerToken;
	private boolean showResults;
	Properties questions;
	
	public OrtoBean() throws Exception
	{
		questionNumber = 1;
		correctAnswers = 0;
		showResults = false;
		
		questions = new Properties();

		questions.load(new FileInputStream("properties"));
	}
	
	public String getQuestionNumber() 
	{
		return Integer.toString(questionNumber);
	}
	
	public String getQuestion()
	{
		return questions.getProperty(Integer.toString(questionNumber));		
	}
	
	public String getAnswer(String which)
	{
		return questions.getProperty(Integer.toString(questionNumber)+which);		
	}
	
	public void setAnswerToken(String token)
	{
		if (token != null)
		{
			answerToken = Integer.parseInt(token);
		}
	}
	
	public void setAnswer(String option)
	{
		if (showResults)
		{
			showResults = false;
			correctAnswers = 0;
		}
		
		if (option != null)
		{
			if (answerToken == questionNumber)
			{
				if (questions.getProperty(Integer.toString(questionNumber)+"answer").equalsIgnoreCase(option))
				{
					correctAnswers++;
				}
				
				questionNumber++;
				
				if (questionNumber > 10)
				{
					questionNumber=1;
					showResults = true;
				}
			}
		}
	}
	
	public String getCorrect()
	{
		return (showResults) ? Integer.toString(correctAnswers) : "";
	}
	
	public String getAnswerA()
	{
		return getAnswer("a");
	}
	
	public String getAnswerB()
	{
		return getAnswer("b");
	}
	
	public String getToken()
	{
		return getQuestionNumber();
	}
	
	public String getResultsVisibility()
	{
		return (showResults) ? "visible" : "hidden";
	}
	
	public String getDialogVisibility()
	{
		return (showResults) ? "hidden" : "visible";
	}
}
