

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import java.io.PrintWriter;
import java.util.ArrayList;

/**
 * Servlet implementation class for Servlet: WojnaServlet
 *
 */
 public class WojnaServlet extends javax.servlet.http.HttpServlet implements javax.servlet.Servlet {
	 final private static long serialVersionUID = 1L; 
	 private String[] players = {"Gracz", "Komputer"};
	 
	 /* (non-Java-doc)
	 * @see javax.servlet.http.HttpServlet#HttpServlet()
	 */
	public WojnaServlet() {
		super();
	}   	

	private String outputMainMenu()
	{
		return "<head><style>* {font-family: verdana; font-size: 8px}</style></head><body><a href=\"?action=newgame\">Nowa gra</a>";
	}
	
	/* (non-Java-doc)
	 * @see javax.servlet.http.HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		PrintWriter out;
		HttpSession session = request.getSession();
		String status = null;
		String action = null;
		
		GameState wojna = null;
		
		response.setContentType("text/html");
		response.setCharacterEncoding("ISO-8859-2");

		out = response.getWriter();
		out.println(outputMainMenu());
		
		if (session.getAttribute("gamestate") != null)
		{
			wojna = (GameState)session.getAttribute("gamestate"); 
		}
		
		if (request.getParameter("action") != null)
		{
			action = request.getParameter("action");
			if (action.equals("newgame"))
			{
				wojna = new GameState(2);
				session.setAttribute("gamestate", wojna);
			}
			else if (action.equals("putcard") && (wojna != null))
			{
				int pl;
				
				for (pl=0; pl<wojna.getPlayersCount(); pl++)
				{
					if (wojna.getPlayerCardsCount(pl) > 0)
					{
						wojna.putCard(pl);
					}
				}
				
				if (wojna.isWar())
				{
					status = "WOJNA!";
					
					for (pl=0; pl<wojna.getPlayersCount(); pl++)
					{
						wojna.putCard(pl);
					}
				}
				else
				{
					status = players[wojna.hasBetterCard()] + " zbiera";
				}
			}
		}
		
		if (wojna != null)
		{
			int pl, i;	
			
			out.println("<table width=\"200\"><tr>");
			for (pl=0; pl<wojna.getPlayersCount(); pl++)
			{
				ArrayList cards = wojna.getPlayerCardsOnTable(pl);
				
				out.println("<td><table><tr><td valign=\"bottom\" height=\"150\">");
				
				if ((action != null) && (action.equals("showcards")))
				{
					ArrayList showcards = wojna.getPlayerCards(pl);
					showcards.addAll(wojna.getPlayerAquiredCards(pl));
					int k;
					for (k=0; k<showcards.size(); k++)
					{
						out.print("<img width=\"40\" src=\"images/"+showcards.get(k).toString()+".png\">");
						if ((((k+1)%5) == 0) && (k>0))
						{
							out.println();
						}
					}
				}
				else
				{
					int k;
					for (k=0; k<wojna.getPlayerCardsCount(pl); k++)
					{
						if (k==0)
						{
							out.println("<img src=\"images/blank.png\"><br>");
						}
						else
						{
							out.println("<img src=\"images/nthblank.png\"><br>");
						}
					}
				}
				out.println("<tr><td><b>"+players[pl]+"</b>&nbsp;<i>("+wojna.getPlayerCards(pl).size()+"+"+(wojna.getPlayerCardsCount(pl)-wojna.getPlayerCards(pl).size())+"&nbsp;kart)</i></td></tr><tr><td>");
				for (i=0; i<cards.size(); i++)
				{
					out.print("<img style=\"display: inline; position: relative; left: "+(-i*80)+"px\" src=\"images/"+cards.get(i).toString()+".png\">");
				}
				out.println("</td></tr>");
				out.println("</table></td>");
				
			}
			out.println("</tr></table>");
			
			if ((wojna.cardsOnTableCount() > 0) && (! wojna.isWar()))
			{
				wojna.giveCardsOnTableTo(wojna.hasBetterCard());
			}
			
			if (wojna.getWinner() != -1)
			{
				out.println("WYGRA "+players[wojna.getWinner()]);
			}
			else 
			{
				if (status != null)
				{
					out.println(status);	
				}
				out.println("<br><a href=\"?action=putcard\">Po kart</a>");
			}
			
			out.println("<br><a href=\"?action=showcards\">Podgldaj karty</a>");
		}
		
	}  	  	  	    
}