package src.logical;

import java.util.ArrayList;
import java.awt.image.BufferedImage;
import java.io.*;
import javax.imageio.*;

import src.logical.Snapshot;

public class Raport {

	private ArrayList snapshoty;
	
	public Raport()
	{
		snapshoty = new ArrayList();
	}
	
	public void addSnapshot(BufferedImage img, String description)
	{
		Snapshot newSnapshot = new Snapshot(img, description);
		snapshoty.add(newSnapshot);
	}
	
	public boolean outputHTML(File outFile)
	{
	    int i;
	    try {
	      OutputStreamWriter out = new OutputStreamWriter(new FileOutputStream(outFile), "UTF-8");
	      out.write("<?xml version=\"1.0\" encoding=\"UTF-8\"?><?xml-stylesheet type=\"text/xsl\" href=\""+outFile.getName()+"_pliki/raport.xsl\"?><profil>");
	      for (i=0; i<snapshoty.size(); i++)
	      {
	    	  Snapshot sn = (Snapshot)snapshoty.get(i);
	    	  try {
	    	        File file = new File(outFile.getParent()+"/"+outFile.getName()+"_pliki\\"+i+".png");
	    	        file.mkdirs();
	    	        ImageIO.write(sn.img, "png", file);
	    	    } catch (IOException e) {
	    	    }
	    	  out.write("<snapshot><description>"+sn.description+"</description><image>"+outFile.getName()+"_pliki/"+i+".png</image></snapshot>");
	      }
	      out.write("</profil>");
	      out.close();
	      
	      // save xsl
	      DataOutputStream out2 =
		        new DataOutputStream(
		          new BufferedOutputStream(
		            new FileOutputStream(outFile.getParent()+"/"+outFile.getName()+"_pliki\\raport.xsl")));
	      out2.writeBytes("<?xml version=\"1.0\" encoding=\"ISO-8859-2\"?><xsl:stylesheet version=\"1.0\" xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\"><xsl:template match=\"/\"><html><head><title>Raport </title><style type=\"text/css\">* {font-family: verdana, sans-serif;font-size: 10px} h1 {font-size: 24px;} h2 {font-size: 16px;} img {border: 1px solid #e0e0e0} </style></head><body style=\"text-align: center\"><h1 style=\"color: red\">StressVisualizator: Raport</h1><h2>Snapshoty</h2><table style=\"width: 700px\"><tbody><xsl:for-each select=\"profil/snapshot\"><tr><td style=\"text-align: center\"><img><xsl:attribute name=\"src\"><xsl:value-of select=\"image\"/></xsl:attribute></img></td></tr><tr><td style=\"text-align: center\"><xsl:value-of select=\"description\"/></td></tr><tr><td> </td></tr></xsl:for-each></tbody></table></body></html></xsl:template></xsl:stylesheet>");
	      out2.close();
	    } catch(Exception e) {
	    }
		return true;
	}
	
}
