#include <process.h>
#include <channel.h>
#include <misc.h>
#include <stdio.h>

#define DATASIZE 50000

char data[DATASIZE] = {2};

int w1  = 0;
int w2  = 0;
int o1a = 0;
int o1b = 0;
int o2a = 0;
int o2b = 0;
int knx = 0;
int kxp = 0;
int kpx = 0;
int kxn = 0;
int stime = 0;

/* wysyla znak, ze to juz koniec */
void send_termination_int(Channel* TOCHANNEL)
{
	ChanOutInt(TOCHANNEL, -1);
}

#ifdef FIRST_IN_CHAIN

char h(int n) {
 return (n<10) ? '0' +n : 'a' + n - 10;
}

/* wypisz pomiar nadajac mu wlasciwa etykiete */
void printresult(int resultno, int host, int dana) {
  char* format[] = {"w%c1 = %d\n",
		    "w%c2 = %d\n",
		    "o%c1a = %d\n",
		    "o%c1b = %d\n",
		    "o%c2a = %d\n",
		    "o%c2b = %d\n",
		    "k%c%c%c = %d\n",
		    "k%c%c%c = %d\n",
		    "k%c%c%c = %d\n",
		    "k%c%c%c = %d\n"};
	switch (resultno) {
	case (6): printf(format[resultno], h(host), h(host+1), h(host), dana); break;
	case (7): printf(format[resultno], h(host), h(host), h(host-1), dana); break;
	case (8): printf(format[resultno], h(host), h(host-1), h(host), dana); break;
	case (9): printf(format[resultno], h(host), h(host), h(host+1), dana); break;
	default: 
	  printf(format[resultno], h(host), dana);
	}

}

/* wyswietlaj swoje dane */
void first_do_show_my_results() {
  printresult(0, 1, w1);
  printresult(1, 1, w2);
  printresult(2, 1, o1a);
  printresult(3, 1, o1b);
  printresult(4, 1, o2a);
  printresult(5, 1, o2b);
  printresult(6, 1, knx);
  printresult(7, 1, kxp);
  printresult(8, 1, kpx);
  printresult(9, 1, kxn);
}

/* wyswietlaj dane otrzymywane od nastepnych */
void first_do_show_next_results(Channel* FROMNEXT)
{
  int i, host, dana;

  do {
    host = ChanInInt(FROMNEXT);
    if (host != -1) {
      for (i=0; i<10; i++) {
	dana = ChanInInt(FROMNEXT);
	printresult(i, host, dana);
      }
    }
  } while (host != -1);
}
#endif

/* przepychacz */
void dig_from(Channel* FROM) {
  ChanIn(FROM, data, 1);
}
void dig_to(Channel* TO) {
  ChanOut(TO, data, 1);
}

/* odbieranie danych - ktos mierzy predkosc do hosta */
void receive(Channel* FROM, int size, int* wtime, int* ktime) {
  int tmp;

  if (size > 0) {
    tmp = ProcTime();
    ChanIn(FROM, data, size);
    *ktime = ProcTimeMinus(ProcTime(), tmp);
  }
}

void send(Channel* TO, int size, int *wtime, int* ktime) {
  int start;

  if (size > 0) {
    start = ProcTime();
    ChanOut(TO, data, size);
    *ktime = ProcTimeMinus(ProcTime(), start);
  }
}

int compute(int size) {
  int start;
  int i;
  int tmp;

  start = ProcTime();

  for (i=0; i<size; i++) {
    tmp = i*i;
  }

  return ProcTimeMinus(ProcTime(), start);
}

void n_send_my_results(int host, Channel* TO) {
  ChanOutInt(TO, host);
  ChanOutInt(TO, w1);
  ChanOutInt(TO, w2);
  ChanOutInt(TO, o1a);
  ChanOutInt(TO, o1b);
  ChanOutInt(TO, o2a);
  ChanOutInt(TO, o2b);
  ChanOutInt(TO, knx);
  ChanOutInt(TO, kxp);
  ChanOutInt(TO, kpx);
  ChanOutInt(TO, kxn);
}

/* przeslanie wynikow nastepnika do poprzednika */
void n_forward_others_results(Channel* FROMNEXT, Channel* TOPREV)
{
  int i, host;
  do {
    host = ChanInInt(FROMNEXT);
    ChanOutInt(TOPREV, host);
    
    if (host != -1)
      {
	for (i=0; i<10; i++) {
	  ChanOutInt(TOPREV, ChanInInt(FROMNEXT));
	}
      }
  } while (host != -1);
}
