#include <process.h>
#include <channel.h>
#include <misc.h>
#include <stdio.h>

#define MINTEST_SIZE 256 
#define MAXTEST_SIZE 4096
#define SIZE_STEP 256
#define REPEAT_COUNT 3

char data[MAXTEST_SIZE] = {0};

/**/
void compute(int size)
{
	int i, a;
	for (i=0; i<size; i++)
	{
	  a = i*i;
	}
}

/* wysyla znak, ze to juz koniec */
void send_termination_int(Channel* TOCHANNEL)
{
	ChanOutInt(TOCHANNEL, -1);
}

#ifdef FIRST_IN_CHAIN
/* pierwszy (ten przyczepiony do hosta) wykonaj test */
void first_do_test(Channel* TONEXT)
{
	int i, repeat, atime, btime;
	for (i=MINTEST_SIZE; i<=MAXTEST_SIZE; i+=SIZE_STEP)
	{
		for (repeat=0; repeat<REPEAT_COUNT; repeat++)
		{
			atime = ProcTime();
			compute(i);
			btime = ProcTime();
			printf("0 %d start %d stop %d time %d\n", i, atime, btime, btime-atime);
		}
	}
	send_termination_int(TONEXT);
}

/* wyswietlaj dane otrzymywane od nastepnych */
void first_do_show_next_results(Channel* FROMNEXT)
{
	int i, host, atime, btime;
	do {
		host = ChanInInt(FROMNEXT);
		if (host != -1)
		{
			i = ChanInInt(FROMNEXT);
			atime = ChanInInt(FROMNEXT);
			btime = ChanInInt(FROMNEXT);
			printf("%d %d start %d stop %d time %d\n", host, i, atime, btime, btime-atime);
		}
	} while (host != -1);
}
#endif

/* odbieranie danych - ktos mierzy predkosc do hosta */
void n_receive_test_data(Channel* FROMPREV)
{
	int i, repeat;
	ChanInInt(FROMPREV); /* receive termination int */
}

/* wysylanie danych - ja mierze predkosc do hosta */
void n_do_test(int host, Channel* TONEXT, Channel* TOPREV)
{
	int i, repeat, atime, btime;
	for (i=MINTEST_SIZE; i<=MAXTEST_SIZE; i+=SIZE_STEP)
	{
		for (repeat=0; repeat<REPEAT_COUNT; repeat++)
		{
			atime = ProcTime();
			compute(i);
			btime = ProcTime();
			
			/* przekazanie do poprzedniego */
			ChanOutInt(TOPREV, host);
			ChanOutInt(TOPREV, i);
			ChanOutInt(TOPREV, atime);
			ChanOutInt(TOPREV, btime);
		}
	}
	send_termination_int(TONEXT);
}

/* przeslanie wynikow nastepnika do poprzednika */
void n_forward_others_results(Channel* FROMNEXT, Channel* TOPREV)
{
	int i, host, atime, btime;
	do {
		host = ChanInInt(FROMNEXT);
		ChanOutInt(TOPREV, host);
		
		if (host != -1)
		{
			i = ChanInInt(FROMNEXT);
			atime = ChanInInt(FROMNEXT);
			btime = ChanInInt(FROMNEXT);
			ChanOutInt(TOPREV, i);
			ChanOutInt(TOPREV, atime);
			ChanOutInt(TOPREV, btime);
		}
	} while (host != -1);
}
